--- qpsmtpd-0.26/lib/Qpsmtpd/SMTP.pm	2003-04-21 05:42:01.000000000 -0400
+++ qpsmtpd.work/lib/Qpsmtpd/SMTP.pm	2003-09-05 12:59:41.000000000 -0400
@@ -335,8 +335,18 @@
   while (<STDIN>) {
     $complete++, last if $_ eq ".\r\n";
     $i++;
-    $self->respond(451, "See http://develooper.com/code/qpsmtpd/barelf.html"), exit
-      if $_ eq ".\n";
+
+    # If we get an improper line, reset the transaction and disconnect
+    if ($_ eq ".\n") {
+	$self->respond(451, "See http://develooper.com/code/qpsmtpd/barelf.html");
+	$self->reset_transaction;
+	$self->disconnect;
+
+	# this is redudant since $self->disconnect calls exit, but it helps
+	# clarify that the program will be closed at this point.
+	exit;
+    };
+
     # add a transaction->blocked check back here when we have line by line plugin access...
     unless (($max_size and $size > $max_size)) {
       s/\r\n$/\n/;
